#!/usr/bin/perl -w

use strict;
use warnings;

my $infile  = "infile.txt";
my $outSeq  = "out_seq.txt";
my $outInfo = "out_info.txt";

open(IN,"$infile") or die "Cannot find $infile\n";
my @inFileCont = <IN>;
close IN;
my $refRec = &fasReader2d(\@inFileCont);
my @recs    = @$refRec;

open(OUT,">$outSeq");
foreach my $ele (@recs) {
  print OUT "$ele->[0]\n";
  my @tempSeq = @{$ele->[1]};
  my $sequence = "";
  for(my $i=0; $i<scalar(@tempSeq); $i++){
    $sequence .= $tempSeq[$i] if $i % 3 == 0;
  }
  for(my $i=0; $i<scalar(@tempSeq); $i++){
    $sequence .= $tempSeq[$i] if $i % 3 == 1;

  }
  print OUT "$sequence\n";
  $sequence = "";
}
close OUT;


open(SEQ,"$outSeq") or die "Cannot find $outSeq\n";
my @seqFileCon = <SEQ>;
close SEQ;
my $refRecSeq = &fasReader2d(\@seqFileCon);
my @recSeqs   = @$refRecSeq;

open(OUTI, ">$outInfo");
my $seqLength = scalar(@{$recSeqs[0]->[1]});
print OUTI "DNA, gene1 = 1-".($seqLength/2)."\n";
print OUTI "DNA, gene2 = ".($seqLength/2+1)."-$seqLength\n";
close OUTI;


exit;

sub fasReader2d{

  my $uniqNameSR = "";
  my $flag = 0;

  my @recs2D = ();
  my @tempSeq = ();
  my $tempSeq = "";

  my ($inFileContSR) = @_;

  foreach my $inFileLine (@$inFileContSR) {
    chomp($inFileLine);
    if($inFileLine =~ /^>/){  
      if($flag == 0){
        $uniqNameSR = $inFileLine;
        $flag = 1;  
      } else {
        my @tempSeqArray = split(//, $tempSeq);
        push(@recs2D, [$uniqNameSR, \@tempSeqArray]);
        $uniqNameSR = $inFileLine;
        $tempSeq = "";
      }
    } else {
      $tempSeq .= $inFileLine;
    }
  }
  my @tempSeqArray = split(//, $tempSeq);
  push(@recs2D, [$uniqNameSR, \@tempSeqArray]);

  return (\@recs2D);
}